<?php
/**
* Events Tab Class for handling the CB Tab API - Version 0.1 Beta 2
* @package Community Builder
* @author Jeffrey Hill - Derived from Joomla Joe's Blog Tab and Eric Lamette/Dave McDonnell/Geraint Edwards Events Component for Joomla! 1.2.1
*/

class getEventsTab extends cbTabHandler {
	function getEventsTab() {
		$this->cbTabHandler();
	}
	
	function _eventsIncludes()  {
    global $mosConfig_absolute_path, $mosConfig_lang;
        include_once($mosConfig_absolute_path."/administrator/components/com_events/events_config.php");
	//	include_once($mosConfig_absolute_path."/components/com_events/events.html.php");
		include_once($mosConfig_absolute_path."/components/com_events/events.class.php");

        if (!defined( '_CAL_LANG_INCLUDED' )) {
            if (file_exists($mosConfig_absolute_path."/components/com_events/language/".$mosConfig_lang.".php") ) {
                include_once($mosConfig_absolute_path."/components/com_events/language/".$mosConfig_lang.".php");
            } else {
                include_once($mosConfig_absolute_path."/components/com_events/language/english.php");
            }
        }
    return true;
    }

	function getDisplayTab($tab,$user,$ui) {
		global $database, $option, $mosConfig_lang, $gid;
		$this->_eventsIncludes();
        // Event list ordering toggles
		$pagingParams = $this->_getPaging(array(),array("events_"));
		switch ($pagingParams["events_sortby"]) {
			case "title":
				$order = "a.title ASC";
				break;
			case "location":
				$order = "a.adresse_info ASC";
				break;
			case "date":
				$order = "a.publish_up ASC";
				break;
			case "hits":
                $order = "a.hits DESC";
                break;
			default:
				$order = "a.publish_up ASC";
				break;
		}
		// Set parameters
		$params       =   $this->params;
		$showcategory =   getLangDefinition($params->get('showCategory', '1'));
		$showlocation =   getLangDefinition($params->get('showLocation', '1'));
		$showhits     =   getLangDefinition($params->get('showHits', '1'));
		$datedisplay  =   getLangDefinition($params->get('dateDisplay', '0'));
		$pagingenabled  = getLangDefinition($params->get('pagingEnabled', '1'));
		$eventsnumber    = getLangDefinition($params->get('eventsNumber', '20'));
        $today = strftime( "%Y-%m-%d" );
        $return = "";
        //Query for event count
        $query = "SELECT COUNT(*)"
		. "\n FROM #__events AS a, #__categories as c"
		. "\n WHERE a.created_by=". $user->id .""
        . "\n AND a.catid = c.id"
		. "\n AND a.publish_down >\"$today 00:00:01\""
		. "\n AND a.state = 1"
        . "\n AND a.access <= $gid"
        ;
        $database->setQuery( $query );
		$total = $database->loadResult();
		if (!is_numeric($total)) $total = 0;
		if (!$total>0) {
			$return = _CAL_LANG_NO_EVENTS;
			return $return;
		}
        if ($pagingParams["events_limitstart"] === null) $pagingParams["events_limitstart"] = "0";
        if ($eventsnumber > $total) $pagingParams["events_limitstart"] = "0";
		if ($tab->description != null)
        {
            $return .= "\t\t<div class=\"tab_Description\">".unHtmlspecialchars(getLangDefinition($tab->description))."</div>\n";
        }
        // Query for a user's events
        $query = "SELECT a.*, c.name"
		. "\n FROM #__events AS a, #__categories as c"
		. "\n WHERE a.created_by=". $user->id .""
        . "\n AND a.catid = c.id"
		. "\n AND a.publish_down >\"$today 00:00:01\""
		. "\n AND a.state = 1"
        . "\n AND a.access <= $gid"
		. "\n ORDER BY ".$order
		. "\n LIMIT ".($pagingParams["events_limitstart"] ? $pagingParams["events_limitstart"] : "0").",".$eventsnumber;
		;
		$database->setQuery( $query );
		//print $database->getQuery();
		$items = $database->loadObjectList();
		
		// Output table header
		$return .= "<table cellpadding=\"5\" cellspacing=\"0\" border=\"0\" width=\"95%\">";
		$return .=    "<tr class=\"sectiontableheader\">";
		$return .=        ($showcategory) ? "<th>&nbsp;</th>" : "";
		$return .=        "<th>".$this->_writeSortByLink($pagingParams,"events_","title",_CAL_LANG_CAL_TITLE)."</th>";
		$return .=        ($showlocation) ? "<th>".$this->_writeSortByLink($pagingParams,"events_","location",_CAL_LANG_EVENT_ADRESSE)."</th>" : "";
		$return .=        "<th>".$this->_writeSortByLink($pagingParams,"events_","date",_CAL_LANG_EVENT_STARTDATE, true)."</th>";
		$return .=        ($showhits) ? "<th>".$this->_writeSortByLink($pagingParams,"events_","hits",_CAL_LANG_EVENT_HITS)."</th>" : "";
		$return .=    "</tr>";
		
		// List out events
		$i = 1;
		foreach($items AS $item) {
			$i = ($i==1) ? 2 : 1;
			$event_up = new mosEventDate( $item->publish_up );
            $eventDate = "";
			$eventTime = (defined("_CAL_USE_STD_TIME") && _CAL_USE_STD_TIME == "YES") ? $event_up->get12hrTime() : $event_up->get24hrTime();$event_up->hour .":". $event_up->minute;
			if ( $item->reccurtype == 1 ) {
				if ( $item->reccurday == 1 ) { $eventDate = _CAL_LANG_MONDAY; }
				if ( $item->reccurday == 2 ) { $eventDate = _CAL_LANG_TUESDAY; }
				if ( $item->reccurday == 3 ) { $eventDate = _CAL_LANG_WEDNESDAY; }
				if ( $item->reccurday == 4 ) { $eventDate = _CAL_LANG_THURSDAY; }
				if ( $item->reccurday == 5 ) { $eventDate = _CAL_LANG_FRIDAY; }
				if ( $item->reccurday == 6 ) { $eventDate = _CAL_LANG_SATURDAY; }
				if ( $item->reccurday == 7 ) { $eventDate = _CAL_LANG_SUNDAY; }
                $eventDate .= "&nbsp;("._CAL_LANG_EACHWEEK.")";
                // } else {
				//echo "(Weekly event)";
				} 
			else {
                $eventDate = mosEventsHTML::getDateFormat($event_up->year,$event_up->month,$event_up->day,$datedisplay);
                }
			$return .= "<tr class=\"sectiontableentry$i\">";
			if ( $showcategory == 1 ) {
                $return .= "<td bgcolor=\"".$item->color_bar."\"><font color=\"white\">".$item->name."</font></td>\n";
                }
            $return .= "<td><a href=\"".sefReltoAbs("index.php?option=com_events&amp;task=view_detail&amp;agid=$item->id")."\">".$item->title."</a></td>\n";
            if ($showlocation == 1) {
                $return .= "<td>".$item->adresse_info."</td>";
              }
            $return .= "<td>".$eventDate."<br/>".$eventTime."</td>\n";
            if ( $showhits == 1 ) {
                $return .= "<td>".$item->hits."</td>\n";
                }
            $return .="</tr>\n";
		    }
	$return .= "</table>\n";
	if ($pagingenabled == 1 && ($eventsnumber < $total)) {
        $return .= "<div style='width:95%;text-align:center;'>"
        .$this->_writePaging($pagingParams,"events_",$eventsnumber,$total)
        ."</div>";
    }
	return $return;
}  //end function getDisplayTab

	function getEditTab($tab,$user,$ui) {
        global $database, $option, $Itemid, $mosConfig_lang, $my, $gid, $mosConfig_absolute_path, $mainframe;
        $this->_eventsIncludes();
        // This line should be thrown into _eventsincludes, really..
        include_once($mosConfig_absolute_path."/includes/sef.php");
        // Set parameters
		$params       =   $this->params;
		$datedisplay  =   getLangDefinition($params->get('dateDisplay', '0'));
        $today = strftime( "%Y-%m-%d" );
        $query = $query = "SELECT a.*, c.name"
		  . "\n FROM #__events AS a, #__categories as c"
	       //. "\n LEFT JOIN #__events_categories AS r ON r.catid=a.catid"
		  . "\n WHERE a.created_by=". $user->id .""
            . "\n AND a.catid = c.id"
		  . "\n AND a.publish_down >\"$today 00:00:01\""
		  . "\n ORDER BY a.publish_up ASC"
		  ;
        $database->setQuery($query);
        //$max_events = $database->loadResult();
        $rows = $database->loadObjectList();
        $total = count($rows);
        $return = "";
        if ($total<=0) {
            $return .= _CAL_LANG_NO_EVENTS; return $return;
        }
        // MLr: discuss replacing _CAL_CONF_EVENT_LIST_ROWS_PPG with $mosConfig_list_limit
        // JH : might happen in 1.3?
        $limit = $limit ? $limit : _CAL_CONF_EVENT_LIST_ROWS_PPG;
        if ( $total <= $limit ) {
            $limitstart = 0;
	    }
        $i          = 1;
        $chdate     = "";
        $return .= "<table align='center' width='95%' cellspacing='0' cellpadding='5'>\n";
        // Row output for published events
        foreach ($rows as $row) {
            $i= ($i==1) ? 2 : 1;
            $event_up   = new mosEventDate( $row->publish_up );
            $link_day   = sprintf( "%02d", $event_up->day );
            $link_month = sprintf( "%02d", $event_up->month );
            $link_year  = sprintf( "%4d", $event_up->year );
            $eventDate  = mosEventsHTML::getDateFormat($event_up->year,$event_up->month,$event_up->day,$datedisplay);
            $url_array = explode("/", $_SERVER['REQUEST_URI']);
            if (in_array("administrator", $url_array))
            {
            $deletelink = "";
            $modifylink = "";
            //$deletelink = "<a href=\"#delete\" onclick=\"return listItemTask('cb$row->id','delete')\"><strong>"._CAL_LANG_DELETE."</strong></a>\n";
            //$modifylink = "<a href=\"#edit\" onclick=\"return listItemTask('cb$row->id','edit')\"><strong>"._CAL_LANG_MODIFY."</strong></a>\n";
            }
            else {
            $deletelink = "<a href=\"".sefRelToAbs("index.php?option=com_events&amp;task=delete&amp;agid=$row->id&amp;year=$link_year&amp;month=$link_month&amp;day=$link_day&amp;Itemid=$Itemid")."\"><strong>"._CAL_LANG_DELETE."</strong></a>\n";
            $modifylink = "<a href=\"".sefRelToAbs("index.php?option=com_events&amp;task=modify&amp;agid=$row->id&amp;year=$link_year&amp;month=$link_month&amp;day=$link_day&amp;Itemid=$Itemid")."\"><strong>"._CAL_LANG_MODIFY."</strong></a>\n";
            }
            if ($eventDate <> $chdate) {
                $return .= "<tr><td>".$eventDate."</td></tr>\n";
            }
            $eventlink=sefRelToAbs("index.php?option=com_events&amp;task=view_detail&amp;agid=".$row->id."&amp;year=".$link_year."&amp;month=".$link_month."&amp;day=".$link_day."&amp;Itemid=".$Itemid);
            $return .= "<tr class=\"sectiontableentry".$i."\"><td><strong><a href=\"".$eventlink."\">".$row->title."</a></strong></td>\n";
            $return .= "<td>".$modifylink."</td>\n";
            $return .= "<td>".$deletelink."</td>\n";
            $return .= "</tr>\n";
            $chdate = $eventDate;
        }
        $return .= "</table><br />\n";
        return $return;
    } //end function getEditTab

	function saveEditTab($tab, $user, $ui, $postdata) {
	}

}	// end class getEventsTab

?>
